/*
 * Copyright (c) 2005 DocJava, Inc. All Rights Reserved.
 */
package bookExamples.ch44Printing;

//Paul S. Underwood
//SW409
//April 13, 2005


import futils.Futil;
import gui.ClosableJFrame;
import gui.In;
import gui.layouts.VerticalFlowLayout;
import utils.PrintUtils;

import javax.swing.*;
import java.awt.*;
import java.awt.print.PageFormat;
import java.awt.print.Paper;
import java.io.File;
import java.util.Calendar;
import java.util.GregorianCalendar;


public class DymoLabelFrame extends ClosableJFrame {
    DymoLabelFrame() {
        setSize(612, 792);
        Container c = getContentPane();
        JPanel borderPanel = new JPanel();
        borderPanel.setLayout(new BorderLayout());
        borderPanel.setBorder(BorderFactory.createEtchedBorder());
        borderPanel.setBackground(Color.white);
        c.setBackground(Color.white);
        c.setLayout(new BorderLayout());
        borderPanel.add(getDateLabel(), BorderLayout.NORTH);
        JPanel p = new JPanel(new VerticalFlowLayout());
        p.setBackground(Color.white);
        populatePanel(p);
        borderPanel.add(p, BorderLayout.CENTER);
        c.add(borderPanel);
        this.setTitle(getDateLabel().getText());
    }

    void populatePanel(JPanel p) {
        //FileList fl = new FileList();
        File f = Futil.getReadDirFileJTree("select a start file");
        //f is a directory; we need to list its contents
        File list[] = f.listFiles();

        JLabel l ;
        for (int i = 0; i < list.length; ++i) {
            //I like listings with 1-based indexes.  So sue me.
            if (list[i].isDirectory()) {
                l = new JLabel('\\' + list[i].getName());
            } else {
                l = new JLabel(list[i].getName());
            }
            p.add(l);
        }
    }

    static JLabel getDateLabel() {
        GregorianCalendar gc = new GregorianCalendar();
        String date = Integer.toString(gc.get(Calendar.YEAR));
        if (gc.get(Calendar.MONTH) < 10) date = date + "0";
        date += Integer.toString(gc.get(Calendar.MONTH) + 1);
        if (gc.get(Calendar.DAY_OF_MONTH) < 10) date = date + "0";
        date += Integer.toString(gc.get(Calendar.DAY_OF_MONTH));
        return new JLabel(date);
    }

    public static void main(String[] args) {
        DymoLabelFrame labelFrame = new DymoLabelFrame();
        labelFrame.setVisible(true);
        try {
            Thread.sleep(200);
        } catch (InterruptedException e) {
          In.message(e);
        }
        PrintUtils printUtils = new PrintUtils(labelFrame);
        //new PrintPreview(printUtils);
        /**
         * getImageableWidth=576.0
         getImageableHeight=734.0
         getImageableX=18.0
         getImageableY=18.0
         getPaper=java.awt.print.Paper@913dc1
         getOrientation=1
         Paper----
         612.0,792.0=w,h
         576.0,734.0=imw,imh
         18.0,18.0=imx,imy
         */
        Paper p = new Paper();
        p.setImageableArea(10, 10, 576, 734);
        p.setSize(612, 792);
        labelFrame.setSize(612, 792);
        labelFrame.setBounds(10, 10, 576, 734);
        PageFormat pf = new PageFormat();
        pf.setPaper(p);
        pf.setOrientation(PageFormat.PORTRAIT);
        printUtils.setGlobalPageFormat(pf);
        printUtils.print();
        printUtils.printFormat();

    }
}
