package cr311h3;

import gui.ClosableJFrame;
import gui.run.RunMenu;
import gui.run.RunMenuBar;
import gui.run.RunMenuItem;
import j2d.ImageUtils;
import j2d.Images;
import j2d.gui.ImagePanel;

import javax.swing.*;
import java.awt.*;
import java.io.File;

import utils.ResourceManager;

/**
 * Copyright 2005, DocJava, Inc.
 * User: dlyon
 * Date: Feb 6, 2006
 * Time: 4:05:54 PM
 */
//todo for hw3 students who are late with their hw, print all the images
// in the catalog on multiple pages (using my solution, if you want).
// This is due by Wednesday (i.e., before thursday).
public class ImageCatalog {
    private Container c = null;
    //private static ResourceManager rm  = ResourceManager.getResourceManager();
    public RunMenu getFileMenu() {
        RunMenu fileMenu = new RunMenu("[File");

        fileMenu.add(new RunMenuItem("[quit{control q}") {
            public void run() {
                System.exit(0);
            }
        });
        fileMenu.add(new RunMenuItem("[Print catalog{control p}") {
            public void run() {
                printCatalog();
                //ImageCatalog.this.print();
            }


        });
        return fileMenu;
    }

    //todo this is implemented for hw3
    //1. Add a file menu to the print catalog frame.
    //2. Add a print menu to the file menu.
    //3. Implement the print menu using
    //    ImageUtils.print(Component c, String title)
    // Don't forget to set your margins so that you have
    // 1 inch borders.
    private void printCatalog() {
        if (c == null) return;
        ImageUtils.print(c, "catalog");
    }


    private JMenuBar getMenuBar() {
        RunMenuBar jm = new RunMenuBar();
        jm.add(getFileMenu());
        return jm;
    }

    public static JPanel getWhitePanel(final int w, final int h) {
        JPanel jp = new JPanel() {
            public Dimension getPreferredSize() {
                return new Dimension(w, h);
            }
        };
        jp.setBackground(Color.WHITE);
        return jp;
    }

    public void appendImages(ImageBrowser imageBrowser, File[] imageFiles) {
        for (int i=0; i < imageFiles.length; i=i+60)
         appendImages(imageBrowser, imageFiles, i);
    }

    private void appendImages(ImageBrowser imageBrowser, File[] imageFiles, int startImage) {
        Images imgs = imageBrowser.getImages();
        ClosableJFrame cf = new ClosableJFrame();

        cf.setJMenuBar(getMenuBar());
        c = cf.getContentPane();
        c.setLayout(new BorderLayout());
        JPanel sp = new JPanel();
        sp.setBackground(Color.WHITE);
        sp.add(getCompositeImagePanel(imgs.getImages(), imageFiles, startImage));

        c.add(getWhitePanel(560, 70), BorderLayout.NORTH);
        c.add(getWhitePanel(70, 700), BorderLayout.WEST);
        c.add(getWhitePanel(70, 700), BorderLayout.EAST);
        c.add(sp, BorderLayout.CENTER);
        // 70 ppi
        // 8x10 inches comes to
        // wxh of 560,700
        cf.setSize(630, 770);
        cf.setVisible(true);

        //print(c);
        //Dimension d = new Dimension(100,100);
        //Image image = imgs.getImage(d,6,8);
        //ImageUtils.displayImage(image,"compositeImage");
    }

    private JPanel getCompositeImagePanel(Image[] img, File[] imageFiles, int startImage) {
        int numberOfImages = 60+startImage;
        final int size = 50;

        JPanel compositeImagePanel = new JPanel();
        compositeImagePanel.setBackground(Color.WHITE);
        compositeImagePanel.setLayout(new GridLayout(0, 6));

        for (int i = startImage; i < numberOfImages; i++) {
            if (i >= img.length) break;
            JPanel jp = new JPanel();
            jp.setBackground(Color.WHITE);
            jp.setLayout(new BorderLayout());
            ImagePanel ip = new ImagePanel() {
                public Dimension getPreferredSize() {
                    return new Dimension(size, size);
                }
            };
            ip.setSize(size, size);
            ip.setLayout(new FlowLayout());
            ip.setImage(ImageUtils.scaleFast(img[i], size, size));
            ip.setPreferredSize(new Dimension(size, size));
            jp.add(ip, BorderLayout.CENTER);
            JLabel jl = new JLabel(imageFiles[i].getName());
            jl.setFont(new Font("times", Font.ITALIC, 10));
            jp.add(jl, BorderLayout.SOUTH);
            compositeImagePanel.add(jp);
        }
        return compositeImagePanel;
    }

    private static void print(Container c) {
        ImageUtils.print(c, "catalog");
    }
}
